** lambda =0.6* gamma* t**(gamma-1)***;
** gamma =1.5;
**   Tmax=2 ***;

%let kappa=1.2;
%let gamma=1.25;
%let Tmax=2;
%let lambda=0.6;
%let nsim=1000000;
%let seed=200;


data exp;
mean = &tmax**&gamma *&lambda;
var= (&kappa * mean +1)*mean;
proc print;
title "med1: mean / variance of number of events";
run;


data med2;
 array t{50} t1 - t50;
do i=1 to &nsim;
  n=0;
  tc=0;
  c =1/&kappa;
  do j=1 to 50;
    t[j]=.;
  end;
  do while (tc<=&Tmax);
    c =  ((uniform(&seed))**(-1/(1/&kappa+n)))*c; 
    tc = ((c-1/&kappa)/&lambda)**(1/&gamma);
    if tc <= &Tmax then do;
    	n=n+1;
	    t[n]=tc;
    end;
   end;
   nnn=n;
   if nnn>3 then nnn=4;
 output;
end;
run;

proc freq data=med2;
table nnn;
run;

proc means data=med2 n mean var std min max;
var n t1 t2 t3;
title "med2: mean / variance of number of events";
run;
