** lambda =0.4+0.2t for t<1 ***;
** lambda =0.6+0.3t for t<1 ***;
**   Tmax=2 ***;

%let kappa=1.5;
%let nsim=1000000;
%let seed=200;




data med2;
 array t{50} t1 - t50;
  adj = (1/&kappa +1)/(1/&kappa+0.5);
  kappa= 1/(1/&kappa +1);
do i=1 to &nsim;
 ** gamma X =beta*rangam(seed,alpha) has mean alpha*beta,
 ** variarance alpha*beta*beta;
  n=0;
  tc=1;
  v= kappa * rangam(&seed,1/kappa)*adj;
  do j=1 to 50;
  t[j]=.;
  end;
  do while (tc<=2);
    c= -log(uniform(&seed))/v + (0.6*tc+0.15*tc*tc);
    tc = (-0.6+sqrt(0.36+0.6*c))/0.3;
    if tc <= 2 then do;
    	n=n+1;
	    t[n]=tc;
    end;
   end;
   nnn=n;
   if nnn>3 then nnn=4;
 output;
end;
run;

proc freq data=med2 ;
table nnn;
run;

proc means data=med2 n mean std var min max;
var n t1 t2 t3;
title "med2: mean / variance of number of events";
run;
