** lambda =0.6* gamma* t**(gamma-1)***;
** gamma =1.5;
**   Tmax=2 ***;
** Thinning method;

%let kappa=1.2;
%let gamma=1.25;
%let Tmax=2;
%let lambda=0.6;
%let nsim=1000000;
%let seed=200;


data exp;
mean = &tmax**&gamma *&lambda;
var= (&kappa * mean +1)*mean;
lambda_m = &lambda * &gamma * (&Tmax**(&gamma-1));
call symput('mlamb', lambda_m);
proc print;
title "med1: mean / variance of number of events";
run;


data med4;
 array t{100} t1 - t100;
do i=1 to &nsim;
  n=0;
  tc=0;
  do j=1 to 100;
  t[j]=.;
  end; 
   v= &kappa * rangam(&seed,1/&kappa);
  do while (tc<&Tmax); 
  ** gamma X =beta*rangam(seed,alpha) has mean alpha*beta,
  ** variarance alpha*beta*beta;
    tc= -log(uniform(&seed))/(v*&mlamb) + tc;
    if (tc <= &Tmax) & (uniform(&seed)<= ((tc/&Tmax)**(&gamma-1))) then do;
    	n=n+1;
	    t[n]=tc;
    end;
   end;
   nnn=n;
   if nnn>3 then nnn=4;
 output;
end;
run;

proc freq data=med4;
table nnn;
run;

proc means data=med4 n mean std var min max;
var n t1 t2 t3;
title "med4: mean / variance of number of events";
run;
